#include <avr/io.h>
#include <util/delay.h>
#include <stdio.h>

#include "serial.h"
#include "spi.h"

#define	DEFAULT_BRIGHTNESS	128

unsigned char picture1[]={
  0,0,128,128,128,128,0,0,
  0,128,0,0,0,0,128,0,
  128,0,255,0,0,255,0,128,
  128,0,0,0,0,0,0,128,
  128,0,255,0,0,255,0,128,
  128,0,0,255,255,0,0,128,
  0,128,0,0,0,0,128,0,
  0,0,128,128,128,128,0,0
  };

unsigned char picture2[]={
  0,0,128,128,128,128,0,0,
  0,128,0,0,0,0,128,0,
  128,0,255,0,0,255,0,128,
  128,0,0,0,0,0,0,128,
  128,0,0,0,0,0,0,128,
  128,0,255,255,255,255,0,128,
  0,128,0,0,0,0,128,0,
  0,0,128,128,128,128,0,0
  };

unsigned char picture3[]={
  0,0,128,128,128,128,0,0,
  0,128,0,0,0,0,128,0,
  128,0,255,0,0,255,0,128,
  128,0,0,0,0,0,0,128,
  128,0,0,0,0,0,0,128,
  128,0,0,255,255,0,0,128,
  0,128,255,0,0,255,128,0,
  0,0,128,128,128,128,0,0
  };

int main(void)
{
init_printf();

printf("Init. SPI\n");
spi_init(1);
_delay_ms(1000);

spi_initcs(&SPI_DDR_DISPLAY,SPI_BIT_DISPLAY);
spi_initcs(&SPI_DDR_MATRIX,SPI_BIT_MATRIX);
spi_unselect(&SPI_PORT_DISPLAY,SPI_BIT_DISPLAY);
spi_unselect(&SPI_PORT_MATRIX,SPI_BIT_MATRIX);

printf("Start SPI Tests\n");

int i;
int num=0;
unsigned char *picture;
while(1){
  char cpt[7];
  sprintf(cpt,"%06d",num);
  spi_select(&SPI_PORT_DISPLAY,SPI_BIT_DISPLAY);
					// Set brightness
  spi_exch(0x83); spi_exch(DEFAULT_BRIGHTNESS-10*(num%10)); _delay_ms(2);
  spi_exch(0x80); _delay_ms(2);		// Clear screen
  					// Set decimal point
  spi_exch(0x81); spi_exch(num%6); _delay_ms(2);
  for(i=0;i<6;i++){ spi_exch(cpt[i]); _delay_ms(2); }
  spi_unselect(&SPI_PORT_DISPLAY,SPI_BIT_DISPLAY);

  spi_select(&SPI_PORT_MATRIX,SPI_BIT_MATRIX);
  switch(num%4){
    case 0: picture=picture1; break;;
    case 1:
    case 3: picture=picture2; break;;
    case 2: picture=picture3; break;;
    default: picture=NULL; break;;
    }
  if(picture) for(i=0;i<64;i++){ spi_exch(picture[i]); _delay_ms(2); }
  spi_unselect(&SPI_PORT_MATRIX,SPI_BIT_MATRIX);
  _delay_ms(1000);
  num++;
  }

return 0;
}
