/************************
*  SPI minimal library  *
************************/

#include <stdio.h>
#include <stdint.h>
#include <avr/io.h>
#include <avr/interrupt.h>  

#include "serial.h"

#include "spi.h"

// Initialisation of SPI bus
void spi_init(unsigned char master)
{
if(master){
  SPI_DDR |= (1<<SPI_MOSI)|(1<<SPI_SCK)|(1<<SPI_SS);
  SPI_DDR &= ~(1<<SPI_MISO);
  }
else{
  SPI_DDR |= (1<<SPI_MISO);
  SPI_DDR &= (~(1<<SPI_MOSI))&(~(1<<SPI_SCK))&(~(1<<SPI_SS));
  }
if(master) SPCR |= (1<<MSTR);
SPCR |= (1<<SPE);
}

// Send byte on SPI bus
uint8_t spi_exch(uint8_t output)
{
SPDR = output;
while(!(SPSR & (1<<SPIF)));
return SPDR;
}

// Initialize chip select
void spi_initcs(volatile unsigned char *ddr,unsigned char bit)
{
*ddr |= (1<<bit);
}

// Select SPI device
void spi_select(volatile unsigned char *port,unsigned char bit)
{
*port &= ~(1<<bit);
}

// Unselect SPI device
void spi_unselect(volatile unsigned char *port,unsigned char bit)
{
*port |= (1<<bit);
}

